require "ease_engine"

class BenchmarkApplication < EaseEngine::Application
  def on_start
    super
    
    @is_update = true
    EaseEngine::Frame.fps = 60
    
    host = ARGV[ 0 ]
    port = ARGV[ 1 ].to_i
    backlog = ARGV[ 2 ].to_i
    backlog = Socket::Constants::SOMAXCONN if backlog <= 0
    
    @tcp_socket = EaseEngine::TCPServer.new( host, port )
    @tcp_socket.listen( backlog )
    add_server_socket( @tcp_socket )
    
    @udp_socket = EaseEngine::UDPSocket.new
    @udp_socket.bind( host, port )
    add_socket( @udp_socket )
    
    EE_LOG_DBG.call "host=#{host} port=#{port} backlog=#{backlog} Socket::Constants::SOMAXCONN=#{Socket::Constants::SOMAXCONN}"
  end
  
  def on_update
    if 1000000 <= @measure.check
      EE_LOG_DBG.call "watcher.size=#{@watcher.size} update_usec=#{@measure.update_usec} count=#{@measure.count}"
      
      @measure.start
    end
  end
  
  def on_read_socket( socket, packet )
    write_packet( socket, packet, 0 )
  end
  
  def on_close_socket( socket )
    case socket
    when @tcp_socket
      EE_LOG_DBG.call "on_close_socket #{socket}"
    when @udp_socket
      EE_LOG_DBG.call "on_close_socket #{socket}"
    end
  end
end
BenchmarkApplication::run
