require "ease_engine"

class BenchmarkApplication < EaseEngine::Application
  def on_start
    super
    
    EaseEngine::Frame.fps = 60
    
    host = ARGV[ 0 ]
    port = ARGV[ 1 ].to_i
    @tcp_num = ARGV[ 2 ].to_i
    @connected_tcp_num = 0
    
    @tcp_num.times{
      add_connect_socket( EaseEngine::TCPSocket.new( host, port ) )
    }
    EE_LOG_DBG.call "host=#{host} port=#{port} tcp_num=#{@tcp_num} watcher.size=#{@watcher.size}"
    
    @measure = EaseEngine::Measure.new
    @measure_update = EaseEngine::Measure.new
    
    @is_update = ( 0 < @tcp_num )
  end
  
  def on_connected_socket( socket )
    @connected_tcp_num += 1
    
    @is_update = false if @tcp_num <= @connected_tcp_num
  end
  
  def on_update
    if 1000000 <= @measure_update.check
      EE_LOG_DBG.call "update_usec=#{@measure_update.update_usec} count=#{@measure_update.count} tcp_num=#{@tcp_num} connected_tcp_num=#{@connected_tcp_num}"
      @measure_update.start
    end
  end
  
  def on_end
    super
    
    @measure.check
    EE_LOG_DBG.call "update_usec=#{@measure.update_usec}"
  end
end
BenchmarkApplication::run
