require "ease_engine"
require "./udp_packet"

class BenchmarkApplication < EaseEngine::Application
  def on_start
    super
    
    @is_update = true
    EaseEngine::Frame.fps = 60
    
    host = ARGV[ 0 ]
    port = ARGV[ 1 ].to_i
    
    udp_socket = EaseEngine::UDPSocket.new
    udp_socket.bind( host, port )
    add_socket( udp_socket )
    
    EE_LOG_DBG.call "host=#{host} port=#{port}"
  end
  
  def on_update
    if 1000000 <= @measure.check
      EE_LOG_DBG.call "watcher.size=#{@watcher.size} update_usec=#{@measure.update_usec} count=#{@measure.count}"
      
      @measure.start
    end
  end
  
  def on_read_socket( socket, packet )
    write_packet( socket, packet, 0 )
  end
end
BenchmarkApplication::run
