require "ease_engine/version"
require "ease_engine/application"

module EaseEngine
  def self.assert( result, *args )
    if ! result
      args = [ "Assert" ] if 0 == args.length
      raise sprintf( *args )
    end
  end
  
  def self.rotate( min, max, value, add )
    return min if value < min || max < value
    
    value += add
    ( value < min || max < value ) ? min : value
  end
  
  def self.trace_info( trace = 0 )
    trace = caller[ trace ] if ! trace.instance_of?( String )
    
    info = {
      :file   => "",
      :line   => 0,
      :method => "",
    }
    if /^(.+?):(\d+)(?::in `(.*)')?/ =~ trace
      info[ :file ]   = $1
      info[ :line ]   = $2.to_i
      info[ :method ] = $3
    end
    info[ :str ] = "#{info[ :file ]}:#{info[ :line ]} #{info[ :method ]}"
    info
  end
end
