require "net/http"

module EaseEngine
  class HTTP
    def self.parse( url )
      uri = URI.parse url
      uri
    end
    
    def self.is_ssl( uri )
      "https" == uri.scheme
    end
    
    def self.get( url, params = {} )
      uri = self.parse url
      uri.query = URI.encode_www_form( params )
      request = Net::HTTP::Get.new uri
      http = Net::HTTP.new( uri.host, uri.port )
      response = http.start{|http|
        http.use_ssl = self.is_ssl( uri )
        http.request request
      }
      
      case response
      when Net::HTTPRedirection
        response = self.get response[ "location" ]
      end
      response
    end
    
    def self.post( url, params = {} )
      uri = self.parse url
      request = Net::HTTP::Post.new uri
      request.set_form_data( params )
      response = Net::HTTP.start( uri.host, uri.port ){|http|
        http.use_ssl = self.is_ssl( uri )
        http.request request
      }
      response
    end
  end
end
