using System;
using System.Diagnostics;

namespace EaseEngine {
  public class Common {
    static public UInt32 Rotate( UInt32 min, UInt32 max, UInt32 value, UInt32 add ){
      if ( value < min || max < value ) return min;
      
      value += add;
      return ( value < min || max < value ) ? min : value;
    }
    
    static public string TraceInfo( StackFrame trace, ref string file, ref int line, ref string method ){
      file = trace.GetFileName();
      line = trace.GetFileLineNumber();
      method = trace.GetMethod().Name;
      return string.Format( "{0}:{1} {2}", file, line, method );
    }
    
    static public string TraceInfo( StackFrame trace ){
      string file = "";
      int line = 0;
      string method = "";
      return TraceInfo( trace, ref file, ref line, ref method );
    }
    
    static public string TraceInfo( int index, ref string file, ref int line, ref string method ){
      return TraceInfo( new StackFrame( index + 1, true ), ref file, ref line, ref method );
    }
    
    static public string TraceInfo( int index ){
      return TraceInfo( new StackFrame( index + 1, true ) );
    }
    
    static public string TraceInfo(){
      return TraceInfo( 1 );
    }
  }
}
