using System;
using System.Text;

namespace EaseEngine {
  public class Buffer {
    protected string    m_value;
    public string Value {
      get { return m_value; }
      set { m_value = value; }
    }
    
    protected int       m_size;
    public int Size {
      get { return m_size; }
      set { m_size = value; }
    }
    
    public Buffer( string value ){
      m_value = value;
      m_size = value.Length;
    }
    
    public Buffer() : this( "" ){
    }
    
    public override string ToString(){
      return m_value;
    }
    
    public string Add( string value ){
      if ( 0 < value.Length ){
        StringBuilder sb = new StringBuilder( m_size + value.Length );
        sb.Append( value );
        m_value = sb.ToString();
        m_size = m_value.Length;
      }
      return m_value;
    }
    
    public string Remove( int size ){
      if ( size <= 0 ) return "";
      
      m_size -= size;
      string removed_str = m_value.Substring( 0, size );
      m_value = m_value.Substring( size );
      return removed_str;
    }
  }
}
