using System;

namespace EaseEngine {
  public class Time {
    protected static DateTime   m_unix_epoch_base_time = new DateTime( 1970, 1, 1 );
    
    protected DateTime          m_value;
    protected DateTime          m_value_unix_epoch_time;
    public DateTime Value {
      get { return m_value; }
      set {
        m_value = value;
        m_value_unix_epoch_time = value.ToUniversalTime();
      }
    }
    
    public Time(){
      Value = DateTime.Now;
    }
    
    public UInt64 ToUnixEpochTimeUSec(){
      return (UInt64)( ( m_value_unix_epoch_time - m_unix_epoch_base_time ).TotalSeconds * 1000000 );
    }
    
    public override string ToString(){
      return string.Format( "{0:0000}/{1:00}/{2:00} {3:00}:{4:00}:{5:00}.{6:000000}",
        m_value.Year, m_value.Month, m_value.Day, m_value.Hour, m_value.Minute, m_value.Second, m_value.Millisecond * 1000 );
    }
    
    public static UInt64 operator-( Time a, Time b ){
      return a.ToUnixEpochTimeUSec() - b.ToUnixEpochTimeUSec();
    }
    
    public bool IsSameDay( Time time ){
      if ( m_value.Day != time.Value.Day ) return false;
      if ( m_value.Month != time.Value.Month ) return false;
      if ( m_value.Year != time.Value.Year ) return false;
      return true;
    }
  }
}
