#if UNITY_EDITOR
using UnityEngine;
using UnityEditor;
using System.Collections;
using System.Threading;

public class Menu : MonoBehaviour {
  [MenuItem("EaseEngine/TestAll")]
  public static void TestAll(){
    TestTime();
    TestBuffer();
    TestMeasure();
    TestTraceInfo();
  }
  
  [MenuItem("EaseEngine/Test/Time")]
  public static void TestTime(){
    var time = new EaseEngine.Time();
    Debug.Log ( time );
    Debug.Log( time.ToUnixEpochTimeUSec() );
    
    Thread.Sleep( 1000 );
    
    var time2 = new EaseEngine.Time();
    Debug.Log ( time2 );
    Debug.Log( time2.ToUnixEpochTimeUSec() );
    Debug.Log( time2 - time );
    Debug.Log( time.IsSameDay( time2 ) );
  }
  
  [MenuItem("EaseEngine/Test/Buffer")]
  public static void TestBuffer(){
    var buffer = new EaseEngine.Buffer();
    Debug.Log( buffer );
    Debug.Log( buffer.Add( "TEST" ) );
    Debug.Log( buffer.Remove( 1 ) );
    Debug.Log( buffer );
  }
  
  [MenuItem("EaseEngine/Test/Measure")]
  public static void TestMeasure(){
    var measure = new EaseEngine.Measure();
    
    Thread.Sleep( 1000 );
    
    measure.Check();
    Debug.Log( "update_usec="+ measure.UpdateUSec +" count="+ measure.Count );
  }
  
  [MenuItem("EaseEngine/Test/TraceInfo")]
  public static void TestTraceInfo(){
    Debug.Log( EaseEngine.Common.TraceInfo() );
    Debug.Log( EaseEngine.Common.TraceInfo( 0 ) );
  }
}
#endif
